<?php
namespace App\Controller;

use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class Address {

    private $addressService;

    public function __construct(\App\Service\Address $addressService) {
        $this->addressService = $addressService;
    }

    public function addAdditionalAddress(Request $request, Response $response) {
        try {
            $params = $request->getParsedBody();
            $dataset = $this->addressService->addAdditionalAddress($params);

            $response->getBody()->write(json_encode([
                'error' => false,
                'message' => '',
                'data' => $dataset
            ]));
    
            return $response->withHeader('Content-Type', 'application/json');
        } catch (\Exception $e) {
            $response->getBody()->write(json_encode([
                'error'   => true,
                'message' => $e->getMessage(),
                'data'    => []
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        }
    }

    public function deleteAdditionalAddress(Request $request, Response $response) {
        try {
            $params = $request->getParsedBody();
            $dataset = $this->addressService->deleteAdditionalAddress($params);

            $response->getBody()->write(json_encode([
                'error' => false,
                'message' => '',
                'data' => $dataset
            ]));
    
            return $response->withHeader('Content-Type', 'application/json');
        } catch (\Exception $e) {
            $response->getBody()->write(json_encode([
                'error'   => true,
                'message' => $e->getMessage(),
                'data'    => []
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        }
    }
}