<?php
namespace App\Factory;

use Doctrine\DBAL\Connection;

class Consumer {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

	public function getConsumersByPhone($NRTELEFONE) 
	{
		$sql = "
			SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR,
			       CO.NMCONSUMIDOR, CO.NRCPFRESPCON,
			       CO.CDTIPOCONS, CO.NRRGCONSUMID,
			       CO.DSEMAILCONS, CO.DTNASCCONS,
			       CO.NRCEPCONS, CO.DSEXIBENDE,
			       'PRINCIPAL' AS CDENDECONS, CO.CDPAIS,
			       CO.DSENDECONS, CO.NRENDECONS,
			       CO.DSCOMPLENDECONS, CO.NRTELECONS,
			       CO.NRCELULARCONS, CO.DSREFERENDECONS,
		 		   CO.NRLATCONS, CO.NRLONGCONS, CO.NMBAIRCONS AS NMBAIRRO,
	               CO.SGESTADO, CO.DSINFOCONS
	
	          FROM CONSUMIDOR CO
	            
	         WHERE (CO.NRTELECONS		= :NRTELECONS
	                OR CO.NRTELE2CONS	= :NRCELULARCONS
	                OR CO.NRCELULARCONS = :NRCELULARCONS)
		";

		$stmt = $this->connection->prepare($sql);
		
		$stmt->bindValue("NRTELECONS", $NRTELEFONE);
		$stmt->bindValue("NRCELULARCONS", $NRTELEFONE);
		$stmt->bindValue("NRCELULARCONS", $NRTELEFONE);

		$result = $stmt->executeQuery();
    	return $result->fetchAllAssociative();
	}

	public function getConsumerAddresses($CDCLIENTE, $CDCONSUMIDOR)
	{
		
		$sql = "
			SELECT CDENDECONS, NOMEENDE, NRCEPCONS, DSENDECONS, NRENDECONS, DSCOMPLENDECONS, 
				   DSREFERENDECONS, NRLATCONS, NRLONGCONS, NMBAIRRO
				FROM ( ( SELECT E.CDENDECONS, E.NOMEENDE, E.NRCEPCONS, E.DSENDECONS, E.NRENDECONS, 
						 E.DSCOMPLENDECONS, E.DSREFERENDECONS, E.NRLATENDE AS NRLATCONS, 
						 E.NRLONGENDE AS NRLONGCONS, E.NMBAIRCONS AS NMBAIRRO
				FROM ENDERECOCONS E 
				WHERE E.CDCLIENTE = :CDCLIENTE AND E.CDCONSUMIDOR = :CDCONSUMIDOR ) 
				UNION ( SELECT 'PRINCIPAL' as CDENDECONS, CO.DSEXIBENDE as NOMEENDE, 
					CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, CO.DSCOMPLENDECONS, CO.DSREFERENDECONS, 
					CO.NRLATCONS, CO.NRLONGCONS, CO.NMBAIRCONS AS NMBAIRRO
				FROM CONSUMIDOR CO 
				WHERE CO.CDCLIENTE = :CDCLIENTE AND CO.CDCONSUMIDOR = :CDCONSUMIDOR ) )
		";

		$stmt = $this->connection->prepare($sql);
		
		$stmt->bindValue("CDCLIENTE", $CDCLIENTE);
		$stmt->bindValue("CDCONSUMIDOR", $CDCONSUMIDOR);

		$result = $stmt->executeQuery();
		
    	return $result->fetchAllAssociative();
	}

	public function getConsumerById($CDCLIENTE, $CDCONSUMIDOR) {
		$sql = "
			SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR,
			CO.NMCONSUMIDOR, CO.NRCPFRESPCON,
			CO.CDTIPOCONS, CO.NRRGCONSUMID,
			CO.DSEMAILCONS, CO.DTNASCCONS,
			CO.NRCEPCONS, CO.DSEXIBENDE,
			'PRINCIPAL' AS CDENDECONS, CO.CDPAIS,
			CO.DSENDECONS, CO.NRENDECONS,
			CO.DSCOMPLENDECONS, CO.NRTELECONS,
			CO.NRCELULARCONS, CO.DSREFERENDECONS,
			CO.CDCONSFACEBOOK, CO.DSENDEIMGCONS,
			CO.CDTOKENCONSFB, CO.DTEXPTOKENFB,
			CO.NRLATCONS, CO.NRLONGCONS, CO.NMBAIRCONS AS NMBAIRRO,
			CO.DSINFOCONS
			FROM CONSUMIDOR CO

			WHERE CO.CDCLIENTE    	= :CDCLIENTE
				AND CO.CDCONSUMIDOR = :CDCONSUMIDOR
		";

		$stmt = $this->connection->prepare($sql);
		
		$stmt->bindValue("CDCLIENTE", $CDCLIENTE);
		$stmt->bindValue("CDCONSUMIDOR", $CDCONSUMIDOR);

		$result = $stmt->executeQuery();
		
    	return $result->fetchAllAssociative();
	}

	public function addConsumer($params)
	{
		
		$sql = "
			INSERT INTO CONSUMIDOR
				(CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, IDSITCONSUMI, CDCCUSCLIE, IDCONSUMIDOR, IDATUCONSUMI,
				IDTPVENDACONS, IDIMPCPFCUPOM, IDCADCONFLIBCON, IDPERCONSPRODEX, IDTPSELMANHA, IDTPSEALMOCO,
				IDTPSELTARDE, IDCRACHAMESTRE, CDPAIS, SGESTADO, CDMUNICIPIO, CDTIPOCONS, CDIDCONSUMID, DSEXIBENDE, DSENDECONS,
				NMBAIRCONS, NRCEPCONS, NRTELECONS, NRRAMAL1CONS, NRTELE2CONS, NRRAMAL2CONS, NRFAXCONS, DSEMAILCONS,
				CDVENDEDOR, NRRGCONSUMID, NRCPFRESPCON, NMRESPCONS, NMLOGINCONS, DSINFOCONS, IDSEXOCONS, DTNASCCONS,
				DSCOMPLENDECONS, DSREFERENDECONS, NRCELULARCONS, CDBAIRRO, NRENDECONS, CDSENHACONSMD5, CDCONSFACEBOOK,
				DSENDEIMGCONS, CDTOKENCONSFB, DTEXPTOKENFB, NRLATCONS, NRLONGCONS)
			VALUES
			(:CDCLIENTE, :CDCONSUMIDOR, :NMCONSUMIDOR, :IDSITCONSUMI, :CDCCUSCLIE, :IDCONSUMIDOR, :IDATUCONSUMI,
				:IDTPVENDACONS, :IDIMPCPFCUPOM, :IDCADCONFLIBCON, :IDPERCONSPRODEX, :IDTPSELMANHA, :IDTPSEALMOCO,
				:IDTPSELTARDE, :IDCRACHAMESTRE, '0055', :SGESTADO, :CDMUNICIPIO, :CDTIPOCONS, :CDIDCONSUMID, :DSEXIBENDE, :DSENDECONS,
				:NMBAIRCONS, :NRCEPCONS, :NRTELECONS, :NRRAMAL1CONS, :NRTELE2CONS, :NRRAMAL2CONS, :NRFAXCONS, :DSEMAILCONS,
				:CDVENDEDOR, :NRRGCONSUMID, :NRCPFRESPCON, :NMRESPCONS, :NMLOGINCONS, :DSINFOCONS, :IDSEXOCONS, :DTNASCCONS,
				:DSCOMPLENDECONS, :DSREFERENDECONS, :NRCELULARCONS, :CDBAIRRO, :NRENDECONS, :CDSENHACONSMD5, :CDCONSFACEBOOK,
				:DSENDEIMGCONS, :CDTOKENCONSFB, TO_DATE(:DTEXPTOKENFB, 'DD/MM/YYYY HH24:MI:SS'), :NRLATCONS, :NRLONGCONS )

		";

		$stmt = $this->connection->prepare($sql);
		
		$stmt->bindValue(':CDCLIENTE', $params['CDCLIENTE']);
		$stmt->bindValue(':CDCONSUMIDOR', $params['CDCONSUMIDOR']);
		$stmt->bindValue(':NMCONSUMIDOR', $params['NMCONSUMIDOR']);
		$stmt->bindValue(':IDSITCONSUMI', $params['IDSITCONSUMI']);
		$stmt->bindValue(':CDCCUSCLIE', $params['CDCCUSCLIE']);
		$stmt->bindValue(':IDCONSUMIDOR', $params['IDCONSUMIDOR']);
		$stmt->bindValue(':IDATUCONSUMI', $params['IDATUCONSUMI']);
		$stmt->bindValue(':IDTPVENDACONS', $params['IDTPVENDACONS']);
		$stmt->bindValue(':IDIMPCPFCUPOM', $params['IDIMPCPFCUPOM']);
		$stmt->bindValue(':IDCADCONFLIBCON', $params['IDCADCONFLIBCON']);
		$stmt->bindValue(':IDPERCONSPRODEX', $params['IDPERCONSPRODEX']);
		$stmt->bindValue(':IDTPSELMANHA', $params['IDTPSELMANHA']);
		$stmt->bindValue(':IDTPSEALMOCO', $params['IDTPSEALMOCO']);
		$stmt->bindValue(':IDTPSELTARDE', $params['IDTPSELTARDE']);
		$stmt->bindValue(':IDCRACHAMESTRE', $params['IDCRACHAMESTRE']);
		$stmt->bindValue(':SGESTADO', $params['SGESTADO']);
		$stmt->bindValue(':CDMUNICIPIO', $params['CDMUNICIPIO']);
		$stmt->bindValue(':CDTIPOCONS', $params['CDTIPOCONS']);
		$stmt->bindValue(':CDIDCONSUMID', $params['CDIDCONSUMID']);
		$stmt->bindValue(':DSEXIBENDE', $params['DSEXIBENDE']);
		$stmt->bindValue(':DSENDECONS', $params['DSENDECONS']);
		$stmt->bindValue(':NMBAIRCONS', $params['NMBAIRCONS']);
		$stmt->bindValue(':NRCEPCONS', $params['NRCEPCONS']);
		$stmt->bindValue(':NRTELECONS', $params['NRTELECONS']);
		$stmt->bindValue(':NRRAMAL1CONS', $params['NRRAMAL1CONS']);
		$stmt->bindValue(':NRTELE2CONS', $params['NRTELE2CONS']);
		$stmt->bindValue(':NRRAMAL2CONS', $params['NRRAMAL2CONS']);
		$stmt->bindValue(':NRFAXCONS', $params['NRFAXCONS']);
		$stmt->bindValue(':DSEMAILCONS', $params['DSEMAILCONS']);
		$stmt->bindValue(':CDVENDEDOR', $params['CDVENDEDOR']);
		$stmt->bindValue(':NRRGCONSUMID', $params['NRRGCONSUMID']);
		$stmt->bindValue(':NRCPFRESPCON', $params['NRCPFRESPCON']);
		$stmt->bindValue(':NMRESPCONS', $params['NMRESPCONS']);
		$stmt->bindValue(':NMLOGINCONS', $params['NMLOGINCONS']);
		$stmt->bindValue(':DSINFOCONS', $params['DSINFOCONS']);
		$stmt->bindValue(':IDSEXOCONS', $params['IDSEXOCONS']);
		$stmt->bindValue(':DTNASCCONS', $params['DTNASCCONS']);
		$stmt->bindValue(':DSCOMPLENDECONS', $params['DSCOMPLENDECONS']);
		$stmt->bindValue(':DSREFERENDECONS', $params['DSREFERENDECONS']);
		$stmt->bindValue(':NRCELULARCONS', $params['NRCELULARCONS']);
		$stmt->bindValue(':CDBAIRRO', $params['CDBAIRRO']);
		$stmt->bindValue(':NRENDECONS', substr($params['NRENDECONS'], 0, 5));
		$stmt->bindValue(':CDSENHACONSMD5', $params['CDSENHACONSMD5']);
		$stmt->bindValue(':CDCONSFACEBOOK', $params['CDCONSFACEBOOK']);
		$stmt->bindValue(':DSENDEIMGCONS', $params['DSENDEIMGCONS']);
		$stmt->bindValue(':CDTOKENCONSFB', $params['CDTOKENCONSFB']);
		$stmt->bindValue(':DTEXPTOKENFB', $params['DTEXPTOKENFB']);
		$stmt->bindValue(':NRLATCONS', $params['NRLATCONS']);
		$stmt->bindValue(':NRLONGCONS', $params['NRLONGCONS']);
		
		return $stmt->executeQuery(); 
	}
}