<?php

namespace App\Factory;

use Doctrine\DBAL\Connection;

class Layout {
  private $connection;

  public function __construct(Connection $connection) {
      $this->connection = $connection;
  }

  public function getLayout() {
    $sql = "
            SELECT * FROM RTLCONTROLLYT
        ";

		$stmt = $this->connection->prepare($sql);
		$result = $stmt->executeQuery();		
		return $result->fetchAllAssociative();
  }

  public function updateLayout($params) {
    $sql = "
            UPDATE RTLCONTROLLYT
              SET IDATIVO = CASE WHEN NMLAYOUT = :NMLAYOUT THEN :IDATIVO ELSE 'N' END,
              DSCOLUNAS = COALESCE(:DSCOLUNAS, DSCOLUNAS)
            WHERE NMLAYOUT = :NMLAYOUT
        ";

    $stmt = $this->connection->executeUpdate($sql, [
      "NMLAYOUT"  => $params['NMLAYOUT'],
      "DSCOLUNAS" => $params['DSCOLUNAS'],
      "IDATIVO"   => $params['IDATIVO'],
    ]);
    return $stmt;
  }

  public function saveLayout($params) {
    $sql = "
            INSERT INTO RTLCONTROLLYT
              (NMLAYOUT, DSCOLUNAS, IDATIVO, CDOPERADOR)
              VALUES (:NMLAYOUT, :DSCOLUNAS, :IDATIVO, :CDOPERADOR)
        ";

    $stmt = $this->connection->executeUpdate($sql, [
      "NMLAYOUT"   => $params['NMLAYOUT'],
      "DSCOLUNAS"  => $params['DSCOLUNAS'],
      "IDATIVO"    => $params['IDATIVO'],
      "CDOPERADOR" => $params['CDOPERADOR'],
    ]);

    return $stmt;
  }

  public function deleteLayout($params) {
    $sql = "
            DELETE RTLCONTROLLYT
              WHERE NMLAYOUT = :NMLAYOUT
        ";

    $stmt = $this->connection->executeUpdate($sql, [
      "NMLAYOUT" => $params['NMLAYOUT'],
    ]);

    return $stmt;
  }
}