import AccessControl, { PermissionMap } from '@/helpers/AccessControl';

const defaultDisabledText = 'Usuário sem permissão';

class GridActionAccessControl {
  setCursor(element: HTMLElement | null, permissions: PermissionMap[]) {
    const hasPermission = AccessControl.isValidAccess(permissions);
    if (element) {
      element.style.cursor = hasPermission ? 'pointer' : 'auto';
    }
  }

  getColor(btnId: string, defaultColor: string, permissions: PermissionMap[]) {
    const disabledColor = '#00000042';
    const hasPermission = AccessControl.isValidAccess(permissions);
    const element = document.getElementById(btnId);
    this.setCursor(element, permissions);
    return hasPermission ? defaultColor : disabledColor;
  }

  getTooltip(permissions: PermissionMap[], defaultText: string, disabledText: string = defaultDisabledText) {
    const hasPermission = AccessControl.isValidAccess(permissions);
    return hasPermission ? defaultText : disabledText;
  }
}

export default new GridActionAccessControl();
