export type MenuItem = {
  name: string,
  label: string,
  icon?: string,
  isActive?: boolean,
  href?: string,
  isMainPage?: boolean,
  submenu?: (MenuItem & {
    isHeader?: boolean,
  })[]
};

export type MenuType = {
  component: string,
  name: string,
  cssClass: string,
  items: MenuItem[],
};

export default {
  component: 'Menu',
  name: 'main-menu',
  cssClass: 'main-menu',
  items: [
    {
      name: 'home-page',
      label: 'Início',
      icon: 'mdi-home',
      isMainPage: true,
      href: '/dashboard',
    },
    {
      name: 'main-page',
      label: 'Acompanhamento de Pedidos',
      icon: 'mdi-food',
      href: '/main-page',
    },
    {
      name: 'operation',
      label: 'operation',
      icon: 'mdi-cog-outline',
      submenu: [
        {
          name: 'block-header',
          label: 'Bloqueios',
          isHeader: true,
        },
        {
          name: 'stores',
          label: 'Lojas',
          href: '/store-block',
          permissions: ['IDBLOQLOJA'],
        },
        {
          name: 'product',
          label: 'Produtos',
          href: '/product-block',
          permissions: ['IDBLOQPROD'],
        },
      ],
    },
    {
      name: 'estimated-delay',
      label: 'Tempo de Atraso',
      icon: 'mdi-clock-outline',
      href: '/estimated-delay',
      permissions: ['IDTEMPOATRASO'],
    },
    {
      name: 'erros-mini',
      label: 'Acompanhamento de Erros de Integração',
      icon: 'mdi-folder-text-outline',
      href: '/erros',
    },
  ],
};
