import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import { Icons } from '@zeedhi/common';
import { DateHelper, dayjs } from '@zeedhi/core';
import router from '../router';
import controllers from '../controllers';
import config from '../config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';
import '../utils/CustomValidation';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
  controllers,
  router,
  config,
});
Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);

vuetify.framework.icons.values = Icons.getIcons() as any;

DateHelper.register('TODAY_REGISTER', 'Hoje', () => {
  const today = dayjs().toDate();
  return [today, today];
});

DateHelper.register('YESTERDAY_REGISTER', 'Ontem', () => {
  const yesterday = dayjs().subtract(1, 'day').toDate();
  return [yesterday, yesterday];
});

DateHelper.register('CURRENT_WEEK_REGISTER', 'Semana Atual', () => {
  const startOfWeek = dayjs().startOf('week').toDate();
  const endOfWeek = dayjs().endOf('week').toDate();
  return [startOfWeek, endOfWeek];
});

DateHelper.register('CURRENT_MONTH_REGISTER', 'Mês Atual', () => {
  const startOfMonth = dayjs().startOf('month').toDate();
  const endOfMonth = dayjs().endOf('month').toDate();
  return [startOfMonth, endOfMonth];
});

DateHelper.register('LAST_MONTH_REGISTER', 'Mês Passado', () => {
  const lastMonthStart = dayjs().subtract(1, 'month').startOf('month').toDate();
  const lastMonthEnd = dayjs().subtract(1, 'month').endOf('month').toDate();
  return [lastMonthStart, lastMonthEnd];
});
